function SEQadm(action)
global scale index Y cp

switch action
   
case 'zoom in'
   set(gcbf,'WindowButtonDownFcn','SEQadm(''set axis'')')
   scale=.5;
   
case 'zoom out'
   set(gcbf,'WindowButtonDownFcn','SEQadm(''set axis'')')
   scale=2;
   
case 'refocus'
   set(gcbf,'WindowButtonDownFcn','SEQadm(''set axis'')')
   scale=1;
   
case 'set axis'
   cp=get(gca,'CurrentPoint');
   cp=cp(1,1:2);
   XLim=get(gca,'XLim');
   YLim=get(gca,'YLim');
   dX=scale*diff(XLim);
   dY=scale*diff(YLim);
   NewXLim=[cp(1)-dX/2 cp(1)+dX/2];
   NewYLim=[cp(2)-dY/2 cp(2)+dY/2];
   set(gca,'XLim',NewXLim,'YLim',NewYLim)
   SEQadm('replot')
   
case 'drag'
   set(gcbf,'WindowButtonDownFcn','SEQadm(''start drag'')')
   
case 'start drag'
   set(gcbf,'WindowButtonMotionFcn','SEQadm(''drag it'')')
   set(gcbf,'WindowButtonUpFcn','SEQadm(''stop drag'')')
   cp=get(gca,'CurrentPoint');
   cp=cp(1,1:2);  
   
case 'drag it'
   newcp=get(gca,'CurrentPoint');
   newcp=newcp(1,1:2);
   dxy=newcp-cp;
   XLim=get(gca,'XLim');
   YLim=get(gca,'YLim');
   XLim=XLim-dxy(1)/5;
   YLim=YLim-dxy(2)/5;
   set(gca,'XLim',XLim,'YLim',YLim)
   SEQadm('replot')
   
case 'stop drag'
   set(gcbf,'WindowButtonMotionFcn','')
   set(gcbf,'WindowButtonUpFcn','')
   SEQadm('replot')
      
case 'replot'
   string=get(fo('x(i)'),'String');
   NN=get(fo('max'),'String');
   XLim=get(gca,'XLim');
   YLim=get(gca,'YLim');
   if isempty(NN) | (length(NN)==5 & NN=='infty')
     N=ceil(XLim(2));
   else
     N=min(str2num(NN),ceil(XLim(2)));
   end
   h=findobj(gcbf,'Type','line');
   for j=1:length(h)
     str=get(h(j),'UserData');
     if (length(str)==2 & str=='[]') | isempty(str)
     else
        X=[];
        Y=[];
        for i=1:N
          a=eval(str);
          Y(i)=a;
          X(i)=i;
        end
        set(h(j),'XData',X,'YData',Y);
     end
   end
   set(fo('x-axis'),'XData',[0 0],'YData',YLim)
   set(fo('y-axis'),'XData',XLim,'YData',[0 0])
   if isempty(findobj('Type','patch'))
   else
     SEQadm('eps')
   end
  
case 'plot'
   YLim=get(gca,'YLim');
   string=get(fo('x(i)'),'String');
   NN=get(fo('max'),'String');
   if isempty(NN) | (length(NN)==5 & NN=='infty')
     XLim=[0 100];
     N=100;
   else
     N=str2num(NN);
     XLim=[0 N+1];
   end
   set(gca,'XLim',XLim)
   hold_string=get(fo('hold'),'String');
   if hold_string=='hold on '
     h=findobj(gcbf,'Type','line')
     set(h,'Tag','old lines','MarkerEdgeColor',[1 0 1])
   else
     cla
     xlabel('i')
     ylabel('x_i')
     h=line([0 N],[0 0],'Color','g','Tag','x-axis','Userdata','0');
     h=line([0 0],YLim,'Color','g','Tag','y-axis','Userdata','0');
   end
   h=line([1 1],[0 0],'Tag','line','Color',[.95 .95 .95],...
     'Marker','.','MarkerEdgeColor',[0 0 1],...
     'UserData',string);
   for n=1:N;
    i=n;
    a=eval(string);
    X=get(fo('line'),'XData');
    Y=get(fo('line'),'YData');
    if i<3
       X(i)=i;
       Y(i)=a;
    else
       X=[X i];
       Y=[Y a];
    end
    set(fo('line'),'XData',X,'YData',Y)
    set(gca,'YLim',[min(Y) max(Y)])
    drawnow
  end

case 'hold'
   string=get(gcbo,'String');
   if string=='hold on '
     hold on
     set(gcbo,'String','hold off')
   elseif string=='hold off'
     hold off
     set(gcbo,'String','hold on ')
   end

case 'scale'
   string=get(gcbo,'String');
   if string=='lin scale'
     set(gcbo,'String','log scale')
     set(gca,'XScale','linear')
   elseif string=='log scale'
     set(gcbo,'String','lin scale')
     set(gca,'XScale','log')
   end
   SEQadm('plot')
 
case 'slide eps'
   e=get(fo('eps slider'),'Value');
   e=e^2;
   set(fo('eps'),'String',num2str(e))
   SEQadm('eps')
   
case 'eps'
   XLim=get(gca,'XLim');
   e=eval(get(fo('eps'),'String'));
   NN=get(fo('max'),'String');
   if isempty(NN) | (length(NN)==5 & NN=='infty')
      N=ceil(XLim(2));
   else
      N=min(str2num(NN),ceil(XLim(2)));
   end
   Y=get(fo('line'),'YData');
   index=N+1;
   i=N;
   while max(Y(i:N))-min(Y(i:N))<e & i>0
      index=i;
      i=i-1;
   end
   limit=(max(Y(index:N))+min(Y(index:N)))/2;
   delete(fo('limit'))
   if index<N
      line([0 N],[limit+e/2 limit+e/2],'Tag','limit');
      line([0 N],[limit-e/2 limit-e/2],'Tag','limit');
      %      line([index index],[-Y(index) Y(index)],'Tag','limit');
      hold on
      h=patch([index N N index],...
         [limit-e/2 limit-e/2 limit+e/2 limit+e/2],'g');
      set(h,'Tag','limit');
      hold off
   end   

end


function o=fo(tag)
o=findobj(gcbf,'Tag',tag);